;/*****************************************************************************
;If you have PnP code available, device PNP0A03 also
;indicates the presence of a PCI controller in the system.
;*****************************************************************************/
;static int pci_detect(void)
;
; Usage:
;     call pci_detect
;
;  It will return the result value in EAX
pci_detect:
  push ebx
  push ecx
  push edx
  push esi
  push edi
    ;printf("PCI controller...");
      mov esi,__pci_detmsg0
       call raw_tty_prn

    ;/* poke 32-bit I/O register at 0xCF8 to see if
    ;there's a PCI controller there */
     ;outportl(PCI_ADR_REG, 0x80000000L); /* bus 0, dev 0, fn 0, reg 0 */
      mov dx,PCI_ADR_REG
      mov eax,0x80000000
       out dx,eax


     ;if(inportl(PCI_ADR_REG) != 0x80000000L)
      mov dx,PCI_ADR_REG
      in eax,dx
       cmp eax,0x80000000
       jz pci_detect_success
     ;{
     ;  printf("not found\n");
        mov esi,__pci_detNO
         call raw_tty_prn
         call tty_doCRLFeffect
     ;  return -1;
        mov eax,-1
        jmp pci_detect_END
     ;}
   pci_detect_success:
     ;printf("found\n");
      mov esi,__pci_detYES
       call raw_tty_prn
       call tty_doCRLFeffect




   xor eax,eax

  pci_detect_END:

  pop edi
  pop esi
  pop edx
  pop ecx
  pop ebx
       ret
__pci_detmsg0 db "PCI controller... ",0
__pci_detYES  db "found",0
__pci_detNO   db "not found",0







































;/*****************************************************************************
;*****************************************************************************/
;static int pci_read_config_byte(pci_t *pci, unsigned reg, unsigned char *val)
; Usage:
;     mov esi,__PCI_MasterOpStruct_ptr
;     mov dx,reg
;     mov edi,__char_8bit_ptr
;       call pci_read_config_byte
;
;  It will return the result value in AX
;
pci_read_config_byte:
  push ebx
  push ecx
  push edx
  push esi
  push edi


   push dx
   xor edx,edx
   pop dx



   push edx            ;GLOBAL "reg"


  ; outportl(PCI_ADR_REG,
  ;                0x80000000L | /* "enable configuration space mapping" */
  ;                ((unsigned long)pci->bus << 16) |       /* b23-b16=bus */
  ;                ((unsigned)pci->dev << 11) |            /* b15-b11=dev */
  ;                ((unsigned)pci->fn << 8) |              /* b10-b8 =fn  */
  ;                (reg & ~3));                            /* b7 -b2 =reg */

   call _____pci_specificles_parm2

  ; *val = inportb(PCI_DATA_REG + (reg & 3));// xxx - is this legit?
   pop ebx        ;GLOBAL "reg"
   and bx,3
     mov dx,PCI_DATA_REG
     add dx,bx
      in al,dx
       mov byte[edi],al
;       stosb     ;guardamos en "*val" de 8 bits


   ;return(0);
     xor eax,eax


  pop edi
  pop esi
  pop edx
  pop ecx
  pop ebx
           ret

















































;/*****************************************************************************
;*****************************************************************************/
;static int pci_read_config_word(pci_t *pci, unsigned reg, unsigned short *val)
; Usage:
;     mov esi,__PCI_MasterOpStruct_ptr
;     mov dx,reg
;     mov edi,__char_16bit_ptr
;       call pci_read_config_byte
;
;  It will return the result value in AX
;
pci_read_config_word:
  push ebx
  push ecx
  push edx
  push esi
  push edi


   push dx
   xor edx,edx
   pop dx



   push edx            ;GLOBAL "reg"




   ; outportl(PCI_ADR_REG, 0x80000000L |
   ;                ((unsigned long)pci->bus << 16) |
   ;                ((unsigned)pci->dev << 11) |
   ;                ((unsigned)pci->fn << 8) | (reg & ~3));

   call _____pci_specificles_parm2

    ;*val = inportw(PCI_DATA_REG + (reg & 2));
     pop ebx        ;GLOBAL "reg"
     and bx,2

       mov dx,PCI_DATA_REG
       add dx,bx
        in ax,dx
         stosw     ;guardamos en "*val" de 16 bits


   ;return(0);
     xor eax,eax

  pop edi
  pop esi
  pop edx
  pop ecx
  pop ebx
            ret











































;/*****************************************************************************
;*****************************************************************************/
;static int pci_read_config_dword(pci_t *pci, unsigned reg, unsigned long *val)
; Usage:
;     mov esi,__PCI_MasterOpStruct_ptr
;     mov dx,reg
;     mov edi,__char_32bit_ptr
;       call pci_read_config_byte
;
;  It will return the result value in AX
;
pci_read_config_dword:
  push ebx
  push ecx
  push edx
  push esi
  push edi


   push dx
   xor edx,edx
   pop dx



   push edx            ;GLOBAL "reg"


   ; outportl(PCI_ADR_REG, 0x80000000L |
   ;                ((unsigned long)pci->bus << 16) |
   ;                ((unsigned)pci->dev << 11) |
   ;                ((unsigned)pci->fn << 8) | (reg & ~3));

   call _____pci_specificles_parm2

    ;*val = inportl(PCI_DATA_REG + 0);
     pop ebx        ;GLOBAL "reg"

       mov dx,PCI_DATA_REG
        in eax,dx
         stosd     ;guardamos en "*val" de 32 bits


   ;return(0);
     xor eax,eax

  pop edi
  pop esi
  pop edx
  pop ecx
  pop ebx
               ret














































;/*****************************************************************************
;*****************************************************************************/
;static int pci_write_config_byte(pci_t *pci, unsigned reg, unsigned val)
; Usage:
;     mov esi,__PCI_MasterOpStruct_ptr
;     mov dx,reg
;     mov al,val
;       call pci_read_config_byte
;
;  It will return the result value in AX
;
pci_write_config_byte:
  push ebx
  push ecx
  push edx
  push esi
  push edi


   push dx
   xor edx,edx
   pop dx


   xor ah,ah
   push ax
   xor eax,eax
   pop ax


   push edx            ;GLOBAL "reg"
   push eax            ;GLOBAL "val"

  ; outportl(PCI_ADR_REG,
  ;                0x80000000L | /* "enable configuration space mapping" */
  ;                ((unsigned long)pci->bus << 16) |       /* b23-b16=bus */
  ;                ((unsigned)pci->dev << 11) |            /* b15-b11=dev */
  ;                ((unsigned)pci->fn << 8) |              /* b10-b8 =fn  */
  ;                (reg & ~3));                            /* b7 -b2 =reg */

   call _____pci_specificles_parm2

  ; outportb(PCI_DATA_REG + (reg & 3), val);
   pop eax        ;GLOBAL "val"
   pop ebx        ;GLOBAL "reg"

   and bx,3         ;(reg & 3)
     mov dx,PCI_DATA_REG
     add dx,bx
      out dx,al


   ;return(0);
     xor eax,eax


  pop edi
  pop esi
  pop edx
  pop ecx
  pop ebx
              ret










































;/*****************************************************************************
;*****************************************************************************/
;static int pci_write_config_word(pci_t *pci, unsigned reg, unsigned val)
; Usage:
;     mov esi,__PCI_MasterOpStruct_ptr
;     mov dx,reg
;     mov ax,val
;       call pci_read_config_word
;
;  It will return the result value in AX
;
pci_write_config_word:
  push ebx
  push ecx
  push edx
  push esi
  push edi


   push dx
   xor edx,edx
   pop dx


   push ax
   xor eax,eax
   pop ax


   push edx            ;GLOBAL "reg"
   push eax            ;GLOBAL "val"

  ; outportl(PCI_ADR_REG,
  ;                0x80000000L | /* "enable configuration space mapping" */
  ;                ((unsigned long)pci->bus << 16) |       /* b23-b16=bus */
  ;                ((unsigned)pci->dev << 11) |            /* b15-b11=dev */
  ;                ((unsigned)pci->fn << 8) |              /* b10-b8 =fn  */
  ;                (reg & ~3));                            /* b7 -b2 =reg */

   call _____pci_specificles_parm2


  ;outportw(PCI_DATA_REG + (reg & 2), val);
   pop eax        ;GLOBAL "val"
   pop ebx        ;GLOBAL "reg"

   and bx,2         ;(reg & 2)
     mov dx,PCI_DATA_REG
     add dx,bx
      out dx,ax


   ;return(0);
     xor eax,eax


  pop edi
  pop esi
  pop edx
  pop ecx
  pop ebx
                ret











































;/*****************************************************************************
;*****************************************************************************/
;static int pci_write_config_dword(pci_t *pci, unsigned reg, unsigned long val)
; Usage:
;     mov esi,__PCI_MasterOpStruct_ptr
;     mov dx,reg
;     mov eax,val
;       call pci_read_config_word
;
;  It will return the result value in AX
;
pci_write_config_dword:
  push ebx
  push ecx
  push edx
  push esi
  push edi


   push dx
   xor edx,edx
   pop dx



   push edx            ;GLOBAL "reg"
   push eax            ;GLOBAL "val"

  ; outportl(PCI_ADR_REG,
  ;                0x80000000L | /* "enable configuration space mapping" */
  ;                ((unsigned long)pci->bus << 16) |       /* b23-b16=bus */
  ;                ((unsigned)pci->dev << 11) |            /* b15-b11=dev */
  ;                ((unsigned)pci->fn << 8) |              /* b10-b8 =fn  */
  ;                (reg & ~3));                            /* b7 -b2 =reg */

   call _____pci_specificles_parm2


  ;outportl(PCI_DATA_REG + 0, val);
   pop eax        ;GLOBAL "val"
   pop ebx        ;GLOBAL "reg"

     mov dx,PCI_DATA_REG
      out dx,eax


   ;return(0);
     xor eax,eax


  pop edi
  pop esi
  pop edx
  pop ecx
  pop ebx
                ret















































;/*****************************************************************************
;*****************************************************************************/
; Usage:
;     mov esi,__PCI_MasterOpStruct_ptr
;       call pci_iterate
;
;  It will return the result value in EAX (AX,AL)
;
;static int pci_iterate(pci_t *pci)
;
pci_iterate:
  push ebx
  push ecx
  push edx
  push esi
  push edi

   ;unsigned char hdr_type = 0x80;   //(byte)__unusedDWORD_0
     mov byte[__unusedDWORD_0],0x80


   ;/* if first function of this device, check if multi-function device
   ;(otherwise fn==0 is the _only_ function of this device) */
   ;if(pci->fn == 0)
    cmp dword[esi+__PCI_MasterOpStruct_getFunction],0
    jnz pci_iterate_cont0
   ;{
   ; if(pci_read_config_byte(pci, 0x0E, &hdr_type))
      ;mov esi,esi
      mov dx,0x0E
      mov edi,__unusedDWORD_0
        call pci_read_config_byte
   ; return -1;      /* error */
   ;}

   pci_iterate_cont0:

   ;/* increment iterators
   ;fn (function) is the least significant, bus is the most significant */
   ;pci->fn++;
     inc dword[esi+__PCI_MasterOpStruct_getFunction]

   ;if(pci->fn >= 8 || (hdr_type & 0x80) == 0)
    cmp dword[esi+__PCI_MasterOpStruct_getFunction],8
     jb pci_iterate_contX
    and byte[__unusedDWORD_0],0x80
    cmp byte[__unusedDWORD_0],0
    jnz pci_iterate_contX
   ;{
   ; pci->fn = 0;
     mov dword[esi+__PCI_MasterOpStruct_getFunction],0
   ; pci->dev++;
     inc dword[esi+__PCI_MasterOpStruct_getDevice]
   ; if(pci->dev >= 32)
     cmp dword[esi+__PCI_MasterOpStruct_getDevice],32
     jb pci_iterate_contX
   ; {
   ;  pci->dev = 0;
     mov dword[esi+__PCI_MasterOpStruct_getDevice],0
   ;  pci->bus++;
     inc dword[esi+__PCI_MasterOpStruct_getBus]
   ;  //if(pci->bus > g_last_pci_bus)
   ;  if(pci->bus > 7)
     cmp dword[esi+__PCI_MasterOpStruct_getBus],7
     jbe pci_iterate_contX
   ;  return 1; /* done */
     mov eax,1
     jmp pci_iterate_END
   ; }
   ;}


  pci_iterate_contX:


  xor eax,eax


 pci_iterate_END:
  pop edi
  pop esi
  pop edx
  pop ecx
  pop ebx
       ret




































 __PCI_MasterOpStruct_forTest:
       __PCI_bus      dd 0
       __PCI_device   dd 1
       __PCI_function dd 0

__testPCIfuncs:
 pusha
 push esi
 push edi

  ;pci_t pci;   ;the struct above
  ;int err;     ;primarily AX

  ;/* check for PCI BIOS */
  ; if(pci_detect())
    call pci_detect
    cmp eax,-1
     jz __testPCIfuncs_END
  ;   return 1;

  ;/* display numeric ID of all PCI devices detected */
  ;        memset(&pci, 0, sizeof(pci));     ;initially we already have a 0
                                             ;filled struct
    mov dword[__PCI_MasterOpStruct_forTest+__PCI_MasterOpStruct_getBus],0
    mov dword[__PCI_MasterOpStruct_forTest+__PCI_MasterOpStruct_getDevice],0
    mov dword[__PCI_MasterOpStruct_forTest+__PCI_MasterOpStruct_getFunction],0





  __testPCIfuncs_doW0:
    ;do
    ;{
    ; unsigned long id;    ;will use __unusedDWORD_1
    ;
    ; /* 00=PCI_VENDOR_ID */
    ; err = pci_read_config_dword(&pci, 0x00, &id);
      mov esi,__PCI_MasterOpStruct_forTest
      mov dx,0
      mov edi,__unusedDWORD_1
        call pci_read_config_dword
    ; if(err)
    ; {
    ;  ERR:
   __testPCIfuncs_ERR:
    ;  printf("Error 0x%02X reading PCI config\n", err);
    ;  return 1;
    ; }
    ; /* anything there? */
    ; if(id != 0xFFFFFFFFL)
      mov ecx,[__unusedDWORD_1]         ;copia del valor para printf()
      cmp dword[__unusedDWORD_1],0xFFFFFFFF
      jz __testPCIfuncs_doW0_END
    ; {
    ;  printf("bus %u, device %2u, function %u: "
    ;  "device=%04lX:%04lX\n", pci.bus,
    ;  pci.dev, pci.fn, id & 0xFFFF, id >> 16);
      ;;;INIT: printf()
      ;;;INIT: printf()
      ;;;INIT: printf()
        mov eax,[__PCI_MasterOpStruct_forTest+__PCI_MasterOpStruct_getBus]
         mov ebx,__unusedDestiny
          call bin2dec
         mov esi,__unusedDestiny
          call raw_tty_prn
          call tty_doCRLFeffect

        mov eax,[__PCI_MasterOpStruct_forTest+__PCI_MasterOpStruct_getDevice]
         mov ebx,__unusedDestiny
          call bin2dec
         mov esi,__unusedDestiny
          call raw_tty_prn
          call tty_doCRLFeffect

        mov eax,[__PCI_MasterOpStruct_forTest+__PCI_MasterOpStruct_getFunction]
         mov ebx,__unusedDestiny
          call bin2dec
         mov esi,__unusedDestiny
          call raw_tty_prn
          call tty_doCRLFeffect

        mov eax,ecx
        and eax,0xFFFF
          mov ebx,__unusedDestiny
           call bin2dec
          mov esi,__unusedDestiny
           call raw_tty_prn
           call tty_doCRLFeffect

        mov eax,ecx
        shr eax,16
          mov ebx,__unusedDestiny
           call bin2dec
          mov esi,__unusedDestiny
           call raw_tty_prn
           call tty_doCRLFeffect

        mov eax,1000
         call tdelay
      ;;;END:  printf()
      ;;;END:  printf()
      ;;;END:  printf()


    ; }

     __testPCIfuncs_doW0_END:
    ;} while(!pci_iterate(&pci));
     mov esi,__PCI_MasterOpStruct_forTest
       call pci_iterate
    cmp eax,0
  jz __testPCIfuncs_doW0



  ;/* find a USB controller */
  ;        memset(&pci, 0, sizeof(pci));
    mov dword[__PCI_MasterOpStruct_forTest+__PCI_MasterOpStruct_getBus],0
    mov dword[__PCI_MasterOpStruct_forTest+__PCI_MasterOpStruct_getDevice],0
    mov dword[__PCI_MasterOpStruct_forTest+__PCI_MasterOpStruct_getFunction],0

  __testPCIfuncs_doW1
    ;do
    ;{
    ; unsigned char major; //(byte)__unusedDWORD_2
    ; unsigned char minor; //(byte)__unusedDWORD_3
    ;
    ; /* 0B=class */
    ; err = pci_read_config_byte(&pci, 0x0B, &major);
    ; if(err)
    ;   goto ERR;
    ; /* 0A=sub-class */
    ; err = pci_read_config_byte(&pci, 0x0A, &minor);
    ; if(err)
    ;   goto ERR;
    ; /* anything there? */
    ; if(major != 0xFF || minor != 0xFF)
    ; {
    ;  printf("detected device of class %u.%u\n", major, minor);
    ;  if(major == 12 && minor == 3)
    ;  {
    ;   printf("USB controller detected\n");
    ;   break;
        jmp __testPCIfuncs_END
    ;  }
    ; }
    ;} while(!pci_iterate(&pci));
    cmp eax,0
  jz __testPCIfuncs_doW1




 __testPCIfuncs_END:

 pop edi
 pop esi
 popa
        ret


















_____pci_specificles_parm2:
  ; outportl(PCI_ADR_REG,
  ;                0x80000000L | /* "enable configuration space mapping" */
  ;                ((unsigned long)pci->bus << 16) |       /* b23-b16=bus */
  ;                ((unsigned)pci->dev << 11) |            /* b15-b11=dev */
  ;                ((unsigned)pci->fn << 8) |              /* b10-b8 =fn  */
  ;                (reg & ~3));                            /* b7 -b2 =reg */

  mov dx,PCI_ADR_REG


  ;;;INIT: parameter 2
  ;;;INIT: parameter 2
  ;;;INIT: parameter 2
   xor eax,eax
   xor ebx,ebx
   xor ecx,ecx

    ;;;INIT: (unsigned long)pci->bus << 16)
    ;;;INIT: (unsigned long)pci->bus << 16)
    ;;;INIT: (unsigned long)pci->bus << 16)
     mov eax,[esi+__PCI_MasterOpStruct_getBus]
     shl eax,16
    ;;;END:  (unsigned long)pci->bus << 16)
    ;;;END:  (unsigned long)pci->bus << 16)
    ;;;END:  (unsigned long)pci->bus << 16)

    ;;;INIT: ((unsigned)pci->dev << 11)
    ;;;INIT: ((unsigned)pci->dev << 11)
    ;;;INIT: ((unsigned)pci->dev << 11)
     mov ebx,[esi+__PCI_MasterOpStruct_getDevice]
     and ebx,00000000000000001111111111111111b
     shl bx,11
    ;;;END:  ((unsigned)pci->dev << 11)
    ;;;END:  ((unsigned)pci->dev << 11)
    ;;;END:  ((unsigned)pci->dev << 11)

    ;;;INIT: (unsigned)pci->fn << 8)
    ;;;INIT: (unsigned)pci->fn << 8)
    ;;;INIT: (unsigned)pci->fn << 8)
     mov ecx,[esi+__PCI_MasterOpStruct_getFunction]
     and ecx,00000000000000001111111111111111b
     shl cx,8
    ;;;END:  (unsigned)pci->fn << 8)
    ;;;END:  (unsigned)pci->fn << 8)
    ;;;END:  (unsigned)pci->fn << 8)
      or eax,ebx
      or eax,ecx
      push eax   ;guardamos el resultado de los 3 anteriores pasos


    ;;;INIT: (reg & ~3)
    ;;;INIT: (reg & ~3)
    ;;;INIT: (reg & ~3)
      push dx
      xor edx,edx
      pop dx

      xor eax,eax
      mov ax,3
      not ax
      and dx,ax

      pop eax      ;recuperamos el valor de los 3 pasos anteriores
       or eax,edx
    ;;;END:  (reg & ~3)
    ;;;END:  (reg & ~3)
    ;;;END:  (reg & ~3)

      push eax       ;guardamos el nuevo resultado
      pop ebx        ;y lo ponemos en EBX

   ;finalmente, el operando fuera del parntesis
    mov eax,0x80000000  ;0x80000000L | /* "enable configuration space mapping" */
    and eax,ebx   ;este es el resultado del segundo parmetro, en EAX

  ;;;END:  parameter 2
  ;;;END:  parameter 2
  ;;;END:  parameter 2
         out dx,eax

               ret


























































__unusedDWORD_0 dd 0
__unusedDWORD_1 dd 0
__unusedDWORD_2 dd 0
__unusedDWORD_3 dd 0
__unusedDWORD_4 dd 0
__unusedDWORD_5 dd 0
__unusedDestiny times 256 db 0
